/* (c)ROBOSOFT, INRIA pierre@robosoft.fr, Tony.Noel@inria.fr
 * This code aims to forward SynDEx binary files to the comm_thread_canX down-
 * loaders (note: this is exclusively a part of the SynDEx RTAI Linux port). */

#include <stdio.h>
#include <fcntl.h>

int main(int argc, char **argv)
{
  int i; /* binary file counter */
  int bin; /* binary file pointer */
  int fd0, fd1; /* Real-time fifos (/dev/rtf0 and /dev/rtf1) */
  unsigned int data, start=1; /* data to transmit and download start command */

/*  if(argc == 1){printf("ERROR: no binary file to forward !\n"); exit(1);}
*/
  if((fd0 = open("/dev/rtf0", O_WRONLY)) < 0) {
    printf("ERROR: Can not open fifo /dev/rtf0 !\n");
    exit(1);
  }
  if((fd1 = open("/dev/rtf1", O_WRONLY)) < 0) {
    printf("ERROR: Can not open fifo /dev/rtf1 !\n");
    exit(1);
  }

  for(i = 1; i < argc; i++) {
    if((bin = open(argv[i], O_RDONLY)) < 0) {
      printf("ERROR: Can not open binary file %s !\n", argv[i]);
      exit(1);
    }

    /* writing binary file into /dev/rtf0 */
    while(read(bin, &data, sizeof(data))) {
      if(write(fd0, &data, sizeof(data)) <0 ){
	printf("ERROR: Can not write data into /dev/rtf0 !\n"); 
	exit(1);
      }
    }
  }

  /* Now, binary file writed in /dev/rtf0. We write something into /dev/rtf1
     to start the download process */
  if(write(fd1, &start, sizeof(start)) < 0){
    printf("ERROR: Can not write data into /dev/rtf1 !\n"); 
    exit(1);
  }

  /* PP: This program is run from a C-Shell run script. This program return 
   *     after download is ended. Then, from the shell, typing `make stop'
   *     cause RTAI application to be removed. */

  return 0;
}  
